wayland::server::zwp_tablet_pad_ring_v2_t(3)

NAME
wayland::server::zwp_tablet_pad_ring_v2_t - pad ring

SYNOPSIS

#include <wayland-server-protocol-unstable.hpp>

Inherits wayland::server::resource_t.

  Public Member Functions

std::function< void(std::string, uint32_t)> & on_set_feedback ()
set compositor feedback
std::function< void()> & on_destroy ()
destroy the ring object
void source (zwp_tablet_pad_ring_v2_source const &source, bool post=true)
ring event source
void angle (double degrees, bool post=true)
angle changed
void stop (bool post=true)
interaction stopped
void frame (uint32_t time, bool post=true)
end of a ring event sequence
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t source_since_version = 1
Minimum protocol version required for the source function.
static constexpr std::uint32_t angle_since_version = 1
Minimum protocol version required for the angle function.
static constexpr std::uint32_t stop_since_version = 1
Minimum protocol version required for the stop function.
static constexpr std::uint32_t frame_since_version = 1
Minimum protocol version required for the frame function.

Detailed Description

pad ring

A circular interaction area, such as the touch ring on the Wacom Intuos Pro series tablets.

Events on a ring are logically grouped by the wl_tablet_pad_ring.frame event.

Definition at line 5634 of file wayland-server-protocol-unstable.hpp.

Member Function Documentation

  void zwp_tablet_pad_ring_v2_t::angle (double degrees, bool post = true)

angle changed

Parameters
    degrees the current angle in degrees

Sent whenever the angle on a ring changes.

The angle is provided in degrees clockwise from the logical north of the ring in the pad's current rotation.

Definition at line 6716 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_pad_ring_v2_t::frame (uint32_t time, bool post = true)

end of a ring event sequence

Parameters
    time timestamp with millisecond granularity

Indicates the end of a set of ring events that logically belong together. A client is expected to accumulate the data in all events within the frame before proceeding.

All wp_tablet_pad_ring events before a wp_tablet_pad_ring.frame event belong logically together. For example, on termination of a finger interaction on a ring the compositor will send a wp_tablet_pad_ring.source event, a wp_tablet_pad_ring.stop event and a wp_tablet_pad_ring.frame event.

A wp_tablet_pad_ring.frame event is sent for every logical event group, even if the group only contains a single wp_tablet_pad_ring event. Specifically, a client may get a sequence: angle, frame, angle, frame, etc.

Definition at line 6726 of file wayland-server-protocol-unstable.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  std::function< void()> & zwp_tablet_pad_ring_v2_t::on_destroy ()

destroy the ring object This destroys the client's resource for this ring object.

Definition at line 6705 of file wayland-server-protocol-unstable.cpp.

  std::function< void(std::string, uint32_t)> & zwp_tablet_pad_ring_v2_t::on_set_feedback ()

set compositor feedback

Parameters
    description ring description
    serial serial of the mode switch event

Request that the compositor use the provided feedback string associated with this ring. This request should be issued immediately after a wp_tablet_pad_group.mode_switch event from the corresponding group is received, or whenever the ring is mapped to a different action. See wp_tablet_pad_group.mode_switch for more details.

Clients are encouraged to provide context-aware descriptions for the actions associated with the ring; compositors may use this information to offer visual feedback about the button layout (eg. on-screen displays).

The provided string 'description' is a UTF-8 encoded string to be associated with this ring, and is considered user-visible; general internationalization rules apply.

The serial argument will be that of the last wp_tablet_pad_group.mode_switch event received for the group of this ring. Requests providing other serials than the most recent one will be ignored.

Definition at line 6699 of file wayland-server-protocol-unstable.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post 'not enough memory' error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void zwp_tablet_pad_ring_v2_t::source (zwp_tablet_pad_ring_v2_source const & source, bool post = true)

ring event source

Parameters
    source the event source

Source information for ring events.

This event does not occur on its own. It is sent before a wp_tablet_pad_ring.frame event and carries the source information for all events within that frame.

The source specifies how this event was generated. If the source is wp_tablet_pad_ring.source.finger, a wp_tablet_pad_ring.stop event will be sent when the user lifts the finger off the device.

This event is optional. If the source is unknown for an interaction, no event is sent.

Definition at line 6711 of file wayland-server-protocol-unstable.cpp.

  void zwp_tablet_pad_ring_v2_t::stop (bool post = true)

interaction stopped Stop notification for ring events.

For some wp_tablet_pad_ring.source types, a wp_tablet_pad_ring.stop event is sent to notify a client that the interaction with the ring has terminated. This enables the client to implement kinetic scrolling. See the wp_tablet_pad_ring.source documentation for information on when this event may be generated.

Any wp_tablet_pad_ring.angle events with the same source after this event should be considered as the start of a new interaction.

Definition at line 6721 of file wayland-server-protocol-unstable.cpp.

Member Data Documentation

  constexpr std::uint32_t wayland::server::zwp_tablet_pad_ring_v2_t::angle_since_version = 1 [static], [constexpr]

Minimum protocol version required for the angle function.

Definition at line 5731 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_pad_ring_v2_t::frame_since_version = 1 [static], [constexpr]

Minimum protocol version required for the frame function.

Definition at line 5775 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_pad_ring_v2_t::source_since_version = 1 [static], [constexpr]

Minimum protocol version required for the source function.

Definition at line 5716 of file wayland-server-protocol-unstable.hpp.

  constexpr std::uint32_t wayland::server::zwp_tablet_pad_ring_v2_t::stop_since_version = 1 [static], [constexpr]

Minimum protocol version required for the stop function.

Definition at line 5751 of file wayland-server-protocol-unstable.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.